/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifndef _fist_tracefs_h
#define _fist_tracefs_h

/* OPTIONAL DECLARATIONS FOLLOW */


  /*
   * base0fs: like lofs, modifies neither file names nor their data
   */

/* MACROS AND STRUCTURES BASED ON FIST FILE tests/tracefs.fist */

/* Name of the file system? */
#define FIST_FSNAME "tracefs"

/* What access mode: readonly, writeonly, or readwrite? */
/* #undef FIST_ACCESSMODE_READONLY */
/* #undef FIST_ACCESSMODE_WRITEONLY */
#define FIST_ACCESSMODE_READWRITE 1

/* Turn on debugging? */
#define FIST_DEBUG 1

/* Turn on dynamic_inode_numbers? */
/* #undef FIST_DYNAMIC_INODE_NUMBERS */

/* Manipulate file data? */
/* #undef FIST_FILTER_DATA */

/* Manipulate file names? */
/* #undef FIST_FILTER_NAME */

/* Size changing algorithm filter? */
/* #undef FIST_FILTER_SCA */

/* What mount style: regular, overlay, or attach? */
#define FIST_MNTSTYLE_REGULAR 1
/* #undef FIST_MNTSTYLE_OVERLAY */
/* #undef FIST_MNTSTYLE_ATTACH */

/* fan-out value */
#define FIST_FANOUT 1

/* What encoding type: none, stream, or block? */
/* #undef FIST_ENCODING_TYPE_NONE */
/* #undef FIST_ENCODING_TYPE_STREAM */
#define FIST_ENCODING_TYPE_BLOCK 1

/* encoding-blocksize VALUE */
#define FIST_ENCODING_BLOCKSIZE 1

/* Error codes? */
/* no error codes defined */

/* Mount flags? */
/* no error codes defined */

/* Mount data arguments? */
/* no mount data defined */

/* Per-VFS data? */
/* no per-VFS data defined */

/* Per-vnode data? */
/* no per-vnode data defined */

/* file formats */
/* using auxiliary sources? */
/* #undef FIST_USE_AUX_SRC */
/* no fileformats defined */

#endif /* not _fist_tracefs_h */
