#!/usr/bin/perl
# Copyright (c) 2003-2007 Erez Zadok
# Copyright (c) 2003-2007 Stony Brook University
# Copyright (c) 2003-2007 The Research Foundation of State University of New York
# Copyright (c) 2004-2007 Nikolai Joukov
# Copyright (c) 2003-2005 Akshat Aranya
# Copyright (c) 2006-2007 Gopala Surya
#
# For specific licensing information, see the COPYING file distributed with
# this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
#
# This Copyright notice must be kept intact and distributed with all
# fistgen sources INCLUDING sources generated by fistgen.


sub usage()
{
	print "gensyscalltable.pl <input header file> <output header file>\n";
}

my $infile = "/usr/include/asm/unistd.h";
my $outfile = "syscalls.h";

if ($ARGV[0] ne "") {
	$infile = $ARGV[0];
}

if ($ARGV[1] ne "") {
	$outfile = $ARGV[1];
}

open (IF, $infile) || die "could not open $infile for reading $!\n";
open (OF, ">$outfile") || die "could not open $outfile for writing $!\n";


print OF <<HEADER;

#ifndef __SYSCALLS_H
#define __SYSCALLS_H
#ifdef _DECLARE_SYSCALL_TABLE_
struct {
	unsigned short id;
	char *name;
} __syscalls[] = {
HEADER
$lowest = 0xffff;
while ($line = <IF>) {
	#print "orig line is $line\n";
	if ($line =~ /^\s*#define\s+__NR_(\w+?)\s+(\d+?)$/) {
		print OF "    { $2, \"$1\" },\n";
		$lowest = $2 if ($2 < $lowest);
	}
}
print OF <<FOOTER;
    { 0, NULL }
};
#endif /* _DECLARE_SYSCALL_TABLE_ */

FOOTER
print OF "#define SYSCALL_OFFSET $lowest\n";
print OF "#endif /* __SYSCALLS_H */\n";
close(OF);
close(IF);


